# swagger-java-client

Faxsuite RESTful API
- API version: 4.0.0
  - Build date: 2023-05-09T10:16:59.047+02:00[Europe/Berlin]

<p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  

  For more information, please visit [https://www.fax-api.de/support/](https://www.fax-api.de/support/)

*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.JobDetailsApi;

import java.io.File;
import java.util.*;

public class JobDetailsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure API key authorization: ApiAuthKey
        ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
        ApiAuthKey.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //ApiAuthKey.setApiKeyPrefix("Token");

        JobDetailsApi apiInstance = new JobDetailsApi();
        String id = "id_example"; // String | Identification number (UUID) of the job
        try {
            Job result = apiInstance.getJob(id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling JobDetailsApi#getJob");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.JobDetailsApi;

import java.io.File;
import java.util.*;

public class JobDetailsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure API key authorization: ApiAuthKey
        ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
        ApiAuthKey.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //ApiAuthKey.setApiKeyPrefix("Token");

        JobDetailsApi apiInstance = new JobDetailsApi();
        String id = "id_example"; // String | Identification number (UUID) of the job
        try {
            Notifications result = apiInstance.getJobNotifications(id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling JobDetailsApi#getJobNotifications");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.JobDetailsApi;

import java.io.File;
import java.util.*;

public class JobDetailsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure API key authorization: ApiAuthKey
        ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
        ApiAuthKey.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //ApiAuthKey.setApiKeyPrefix("Token");

        JobDetailsApi apiInstance = new JobDetailsApi();
        String id = "id_example"; // String | Identification number (UUID) of the job
        try {
            Preview result = apiInstance.getJobPreviews(id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling JobDetailsApi#getJobPreviews");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.JobDetailsApi;

import java.io.File;
import java.util.*;

public class JobDetailsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure API key authorization: ApiAuthKey
        ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
        ApiAuthKey.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //ApiAuthKey.setApiKeyPrefix("Token");

        JobDetailsApi apiInstance = new JobDetailsApi();
        String id = "id_example"; // String | Identification number (UUID) of the job
        Integer objectLimit = 100; // Integer | Query parameter to change de default limitation of objects in the result data array
        Integer objectOffset = 0; // Integer | Query parameter to change de default offset of objects in the result data array
        String filterFaxNumber = "filterFaxNumber_example"; // String | Query parameter to fetch recipients after his fax number
        String filterFaxNumberNorm = "filterFaxNumberNorm_example"; // String | Query parameter to fetch recipients after his normed fax number
        String filterRecipientReference = "filterRecipientReference_example"; // String | Query parameter to fetch recipients after his recipient reference
        String filterInternationalDialingCode = "filterInternationalDialingCode_example"; // String | Query parameter to fetch recipients after his international dialing code
        String filterResultCode = "filterResultCode_example"; // String | Query parameter to fetch recipients after his result code
        String filterResultText = "filterResultText_example"; // String | Query parameter to fetch recipients after his result text
        String sortField = "sortField_example"; // String | Available sort options for the result data array.
        String sortOrder = "asc"; // String | Describes the order for used sort fields
        try {
            JobRecipients result = apiInstance.getJobRecipients(id, objectLimit, objectOffset, filterFaxNumber, filterFaxNumberNorm, filterRecipientReference, filterInternationalDialingCode, filterResultCode, filterResultText, sortField, sortOrder);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling JobDetailsApi#getJobRecipients");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.JobDetailsApi;

import java.io.File;
import java.util.*;

public class JobDetailsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure API key authorization: ApiAuthKey
        ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
        ApiAuthKey.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //ApiAuthKey.setApiKeyPrefix("Token");

        JobDetailsApi apiInstance = new JobDetailsApi();
        String id = "id_example"; // String | Identification number (UUID) of the job
        try {
            Templates result = apiInstance.getJobTemplates(id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling JobDetailsApi#getJobTemplates");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.JobDetailsApi;

import java.io.File;
import java.util.*;

public class JobDetailsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();

        // Configure API key authorization: ApiAuthKey
        ApiKeyAuth ApiAuthKey = (ApiKeyAuth) defaultClient.getAuthentication("ApiAuthKey");
        ApiAuthKey.setApiKey("YOUR API KEY");
        // Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
        //ApiAuthKey.setApiKeyPrefix("Token");

        JobDetailsApi apiInstance = new JobDetailsApi();
        JobsIdBody body = new JobsIdBody(); // JobsIdBody | Describes the required request body to perform an action on the fax job
        String id = "id_example"; // String | Identification number (UUID) of the job
        try {
            Job result = apiInstance.putJob(body, id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling JobDetailsApi#putJob");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://service.fax-api.de/4.0/rest*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*JobDetailsApi* | [**getJob**](docs/JobDetailsApi.md#getJob) | **GET** /jobs/{id} | /jobs/{id}
*JobDetailsApi* | [**getJobNotifications**](docs/JobDetailsApi.md#getJobNotifications) | **GET** /jobs/{id}/notifications | /jobs/{id}/notifications
*JobDetailsApi* | [**getJobPreviews**](docs/JobDetailsApi.md#getJobPreviews) | **GET** /jobs/{id}/preview | /jobs/{id}/preview
*JobDetailsApi* | [**getJobRecipients**](docs/JobDetailsApi.md#getJobRecipients) | **GET** /jobs/{id}/recipients | /jobs/{id}/recipients
*JobDetailsApi* | [**getJobTemplates**](docs/JobDetailsApi.md#getJobTemplates) | **GET** /jobs/{id}/templates | /jobs/{id}/templates
*JobDetailsApi* | [**putJob**](docs/JobDetailsApi.md#putJob) | **PUT** /jobs/{id} | /jobs/{id}
*JobsApi* | [**getJobs**](docs/JobsApi.md#getJobs) | **GET** /jobs | /jobs
*JobsApi* | [**postJob**](docs/JobsApi.md#postJob) | **POST** /jobs | /jobs
*RecipientsApi* | [**getRecipients**](docs/RecipientsApi.md#getRecipients) | **GET** /recipients | /recipients
*SystemApi* | [**getHealth**](docs/SystemApi.md#getHealth) | **GET** /health | /health

## Documentation for Models

 - [ErrorAuthenticationResponse](docs/ErrorAuthenticationResponse.md)
 - [ErrorBadRequestResponse](docs/ErrorBadRequestResponse.md)
 - [ErrorInternalServerResponse](docs/ErrorInternalServerResponse.md)
 - [ErrorNotFoundResponse](docs/ErrorNotFoundResponse.md)
 - [ErrorServiceNotAvailableResponse](docs/ErrorServiceNotAvailableResponse.md)
 - [ErrorToManyRequestsResponse](docs/ErrorToManyRequestsResponse.md)
 - [Health](docs/Health.md)
 - [InlineResponse201](docs/InlineResponse201.md)
 - [Job](docs/Job.md)
 - [JobInfo](docs/JobInfo.md)
 - [JobOptions](docs/JobOptions.md)
 - [JobPost](docs/JobPost.md)
 - [JobPostOptions](docs/JobPostOptions.md)
 - [JobPostRecipient](docs/JobPostRecipient.md)
 - [JobRecipient](docs/JobRecipient.md)
 - [JobRecipients](docs/JobRecipients.md)
 - [JobStatistics](docs/JobStatistics.md)
 - [Jobs](docs/Jobs.md)
 - [JobsIdBody](docs/JobsIdBody.md)
 - [Notification](docs/Notification.md)
 - [Notifications](docs/Notifications.md)
 - [Preview](docs/Preview.md)
 - [Recipient](docs/Recipient.md)
 - [RecipientJob](docs/RecipientJob.md)
 - [Recipients](docs/Recipients.md)
 - [Template](docs/Template.md)
 - [Templates](docs/Templates.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### ApiAuthKey

- **Type**: API key
- **API key parameter name**: X-Auth-Token
- **Location**: HTTP header


## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author

support@fax-api.de
