/*
 * Faxsuite RESTful API
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.JobPostOptions;
import io.swagger.client.model.JobPostRecipient;
import io.swagger.client.model.Template;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
/**
 * Describes the needed request body for creating a new fax job
 */
@Schema(description = "Describes the needed request body for creating a new fax job")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-05-09T10:16:59.047+02:00[Europe/Berlin]")
public class JobPost {
  @SerializedName("options")
  private JobPostOptions options = null;

  @SerializedName("templates")
  private List<Template> templates = new ArrayList<Template>();

  @SerializedName("recipients")
  private List<JobPostRecipient> recipients = null;

  @SerializedName("distributionLists")
  private List<String> distributionLists = null;

  public JobPost options(JobPostOptions options) {
    this.options = options;
    return this;
  }

   /**
   * Get options
   * @return options
  **/
  @Schema(description = "")
  public JobPostOptions getOptions() {
    return options;
  }

  public void setOptions(JobPostOptions options) {
    this.options = options;
  }

  public JobPost templates(List<Template> templates) {
    this.templates = templates;
    return this;
  }

  public JobPost addTemplatesItem(Template templatesItem) {
    this.templates.add(templatesItem);
    return this;
  }

   /**
   * Describes an array of template documents. One is required. 5 templates are max 
   * @return templates
  **/
  @Schema(required = true, description = "Describes an array of template documents. One is required. 5 templates are max ")
  public List<Template> getTemplates() {
    return templates;
  }

  public void setTemplates(List<Template> templates) {
    this.templates = templates;
  }

  public JobPost recipients(List<JobPostRecipient> recipients) {
    this.recipients = recipients;
    return this;
  }

  public JobPost addRecipientsItem(JobPostRecipient recipientsItem) {
    if (this.recipients == null) {
      this.recipients = new ArrayList<JobPostRecipient>();
    }
    this.recipients.add(recipientsItem);
    return this;
  }

   /**
   * Describes an array of recipients. One is required if distribution list is not used. 9999 recipient are max 
   * @return recipients
  **/
  @Schema(description = "Describes an array of recipients. One is required if distribution list is not used. 9999 recipient are max ")
  public List<JobPostRecipient> getRecipients() {
    return recipients;
  }

  public void setRecipients(List<JobPostRecipient> recipients) {
    this.recipients = recipients;
  }

  public JobPost distributionLists(List<String> distributionLists) {
    this.distributionLists = distributionLists;
    return this;
  }

  public JobPost addDistributionListsItem(String distributionListsItem) {
    if (this.distributionLists == null) {
      this.distributionLists = new ArrayList<String>();
    }
    this.distributionLists.add(distributionListsItem);
    return this;
  }

   /**
   * Describes an array of distribution lists identification numbers. One is required if recipients lists is not used
   * @return distributionLists
  **/
  @Schema(description = "Describes an array of distribution lists identification numbers. One is required if recipients lists is not used")
  public List<String> getDistributionLists() {
    return distributionLists;
  }

  public void setDistributionLists(List<String> distributionLists) {
    this.distributionLists = distributionLists;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    JobPost jobPost = (JobPost) o;
    return Objects.equals(this.options, jobPost.options) &&
        Objects.equals(this.templates, jobPost.templates) &&
        Objects.equals(this.recipients, jobPost.recipients) &&
        Objects.equals(this.distributionLists, jobPost.distributionLists);
  }

  @Override
  public int hashCode() {
    return Objects.hash(options, templates, recipients, distributionLists);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class JobPost {\n");
    
    sb.append("    options: ").append(toIndentedString(options)).append("\n");
    sb.append("    templates: ").append(toIndentedString(templates)).append("\n");
    sb.append("    recipients: ").append(toIndentedString(recipients)).append("\n");
    sb.append("    distributionLists: ").append(toIndentedString(distributionLists)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
