/*
 * Faxsuite RESTful API
 * <p><img src=\"https://service.fax-api.de/4.0/img/fax-api.png\" height=\"100\" title=\"title\" /></p>  # API Definition <p><img src=\"https://service.fax-api.de/4.0/img/open_api.png\" height=\"50\" title=\"title\" /></p>  Die <b>RESTful API</b> basiert auf den <b>OpenAPI v3.0.3</b> Spezifikationen. OpenAPI Spezifikationen (OAS) definieren eine standardisierte und programmiersprachenunabhängige Schnittstellenbeschreibung für RESTful APIs. Diese Schnittstelle ist nutzbar ohne dass der Zugang zum Quellcode, zusätzliche Dokumentation oder die Untersuchung des Netzwerk-Traffics erforderlich ist. Somit kann ein Nutzer den Dienst mit einem Minimum an Implementierungslogik verstehen, mit ihm interagieren und einfach und schnell als API-Schnittstelle in seine eigene Softwareanwendung integrieren..<br><br>Weitere Informationen zu OpenAPI finden sie hier: <a href=\"https://www.openapis.org/\"><b>https://www.openapis.org/</b></a>   # Einleitung  <p><img src=\"https://service.fax-api.de/4.0/img/fax-api-faxsuite_v2.png\" height=\"350\" title=\"title\" />  </p>  Mit unserer <b>Faxsuite</b> können Sie überall und zu jederzeit Faxe senden und empfangen. Neben vielen anderen Funktionalitäten bietet Ihnen unsere <b>Faxsuite</b> auch eine RESTFul API-Schnittstelle. Damit können Sie z. B. aus Ihrer eigenen Softwareanwendung Faxe automatisiert versenden. Zeitintensive und teure Investionen in Hardware und Software gehören der Vergangenheit an und sind nicht mehr notwendig..<br><br>Um den API Service nutzen zu können, müssen Sie sich für die <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a> anmelden. Ein kostenloser Testzugang kann <a href=\"https://www.faxverteiler.com/testzugang/\"><b>hier</b></a> beantragt werden. (<i>To use the API service you need to sign up for the <a href=\"https://www.faxsuite.de/\"><b>Faxsuite</b></a>. A free trial access can be requested <a href=\"https://www.faxverteiler.com/testzugang/\"><b>here</b></a></i>).<br><br>Mit der <b>Faxsuite</b> haben Sie die Kontrolle über Ihre Fax-Kampangen. Mit dem kostenlosen Testzugang können Sie alle Faxsuite Module (Fax-API, Mail2Fax, Faxdrucker, Faxmailing und Faxempfang) unverbindlich ausprobieren. Sie bekommen 10 kostenlose Faxseiten, die Sie zum aktiven Kennenlernen unserer Faxsuite nutzen können. (<i>You can test the <b>Faxsuite</b> modules for four weeks without obligation. You will receive 10 free fax pages with the free trial access</i>)<br><br>Nachdem Sie den Zugang beantragt haben, können Sie sich <a href=\"https://www.faxsuite.de/\"><b>hier</b></a> in die <b>Faxsuite</b> einloggen. Unter dem Menüpunkt 'FAX-API | Konto verwalten' können Sie ein neues Fax-API Konto erstellen. Bei der Erstellung des Fax-API Kontos wird automatisch ein Autorisierungs-Schlüssel generiert, welchen Sie für den Zugang zur API-Schnittstelle benötigen. (<i>After creating a login you can access the <b>Faxsuite</b> <a href=\"https://www.faxsuite.de/\"><b>here</b></a>. In the menu 'FAX-API | Konto verwalten' you can create a new API-Account and receive the related token/key you need to gain access to our API service</i>).<br><br>Die standardisierte API Dokumentation wird Ihnen in zwei unterschiedlichen, als nicht <b>interaktive</b> und <b>interaktive</b> Varinaten angeboten:  |Name|Type|Link| |-----|-----|-------| | <b>Redoc</b> | non interactive | <b><a href=\"https://service.fax-api.de/4.0/rest/index.html\">click here for redoc</a></b> | <b>Swagger UI</b> | interactive (self hosted) | <b><a href=\"https://service.fax-api.de/4.0/rest/swagger-ui/index.html\">click here for swagger</a></b> |  
 *
 * OpenAPI spec version: 4.0.0
 * Contact: support@fax-api.de
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.client.model.RecipientJob;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
import org.threeten.bp.OffsetDateTime;
/**
 * Model of containing recipient information
 */
@Schema(description = "Model of containing recipient information")
@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2023-05-09T10:16:59.047+02:00[Europe/Berlin]")
public class Recipient {
  @SerializedName("job")
  private RecipientJob job = null;

  @SerializedName("faxNumber")
  private String faxNumber = null;

  @SerializedName("faxNumberNorm")
  private String faxNumberNorm = null;

  @SerializedName("internationalDialingCode")
  private String internationalDialingCode = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("recipientReference")
  private String recipientReference = null;

  @SerializedName("fareZone")
  private Integer fareZone = null;

  @SerializedName("senderTime")
  private OffsetDateTime senderTime = null;

  @SerializedName("resultCode")
  private Integer resultCode = null;

  @SerializedName("resultText")
  private String resultText = null;

  public Recipient job(RecipientJob job) {
    this.job = job;
    return this;
  }

   /**
   * Get job
   * @return job
  **/
  @Schema(description = "")
  public RecipientJob getJob() {
    return job;
  }

  public void setJob(RecipientJob job) {
    this.job = job;
  }

  public Recipient faxNumber(String faxNumber) {
    this.faxNumber = faxNumber;
    return this;
  }

   /**
   * Recipient fax number
   * @return faxNumber
  **/
  @Schema(example = "0525187929399", description = "Recipient fax number")
  public String getFaxNumber() {
    return faxNumber;
  }

  public void setFaxNumber(String faxNumber) {
    this.faxNumber = faxNumber;
  }

  public Recipient faxNumberNorm(String faxNumberNorm) {
    this.faxNumberNorm = faxNumberNorm;
    return this;
  }

   /**
   * Normed recipient fax number
   * @return faxNumberNorm
  **/
  @Schema(example = "0525187929399", description = "Normed recipient fax number")
  public String getFaxNumberNorm() {
    return faxNumberNorm;
  }

  public void setFaxNumberNorm(String faxNumberNorm) {
    this.faxNumberNorm = faxNumberNorm;
  }

  public Recipient internationalDialingCode(String internationalDialingCode) {
    this.internationalDialingCode = internationalDialingCode;
    return this;
  }

   /**
   * The International Dialing Code used for this fax
   * @return internationalDialingCode
  **/
  @Schema(example = "0049", description = "The International Dialing Code used for this fax")
  public String getInternationalDialingCode() {
    return internationalDialingCode;
  }

  public void setInternationalDialingCode(String internationalDialingCode) {
    this.internationalDialingCode = internationalDialingCode;
  }

  public Recipient name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Recipient name
   * @return name
  **/
  @Schema(example = "Max Mustermann", description = "Recipient name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public Recipient recipientReference(String recipientReference) {
    this.recipientReference = recipientReference;
    return this;
  }

   /**
   * Recipient reference
   * @return recipientReference
  **/
  @Schema(example = "User 1234 ABC", description = "Recipient reference")
  public String getRecipientReference() {
    return recipientReference;
  }

  public void setRecipientReference(String recipientReference) {
    this.recipientReference = recipientReference;
  }

  public Recipient fareZone(Integer fareZone) {
    this.fareZone = fareZone;
    return this;
  }

   /**
   * Used fare zone for the fax
   * @return fareZone
  **/
  @Schema(example = "1", description = "Used fare zone for the fax")
  public Integer getFareZone() {
    return fareZone;
  }

  public void setFareZone(Integer fareZone) {
    this.fareZone = fareZone;
  }

  public Recipient senderTime(OffsetDateTime senderTime) {
    this.senderTime = senderTime;
    return this;
  }

   /**
   * Time fax was send to recipient. The format complies with ISO 8601 and contains date and time
   * @return senderTime
  **/
  @Schema(example = "2022-01-01T10:00+02:00", description = "Time fax was send to recipient. The format complies with ISO 8601 and contains date and time")
  public OffsetDateTime getSenderTime() {
    return senderTime;
  }

  public void setSenderTime(OffsetDateTime senderTime) {
    this.senderTime = senderTime;
  }

  public Recipient resultCode(Integer resultCode) {
    this.resultCode = resultCode;
    return this;
  }

   /**
   * Contains the result code for the fax. Value is only present if a result of the fax transmission is available, otherwise it is &#x27;null&#x27;. Please see here for further information: &lt;a href&#x3D;\&quot;https://hilfe.faxverteiler.com/ergebnis-code/\&quot;&gt;&lt;b&gt;https://hilfe.faxverteiler.com/ergebnis-code/&lt;/b&gt;&lt;/a&gt;
   * @return resultCode
  **/
  @Schema(example = "0", description = "Contains the result code for the fax. Value is only present if a result of the fax transmission is available, otherwise it is 'null'. Please see here for further information: <a href=\"https://hilfe.faxverteiler.com/ergebnis-code/\"><b>https://hilfe.faxverteiler.com/ergebnis-code/</b></a>")
  public Integer getResultCode() {
    return resultCode;
  }

  public void setResultCode(Integer resultCode) {
    this.resultCode = resultCode;
  }

  public Recipient resultText(String resultText) {
    this.resultText = resultText;
    return this;
  }

   /**
   * Contains the result text for the fax. Value is only present if a result of the fax transmission is available, otherwise it is &#x27;null&#x27;. Please see here for further information: &lt;a href&#x3D;\&quot;https://hilfe.faxverteiler.com/ergebnis-code/\&quot;&gt;&lt;b&gt;https://hilfe.faxverteiler.com/ergebnis-code/&lt;/b&gt;&lt;/a&gt;
   * @return resultText
  **/
  @Schema(example = "The fax was sent successfully", description = "Contains the result text for the fax. Value is only present if a result of the fax transmission is available, otherwise it is 'null'. Please see here for further information: <a href=\"https://hilfe.faxverteiler.com/ergebnis-code/\"><b>https://hilfe.faxverteiler.com/ergebnis-code/</b></a>")
  public String getResultText() {
    return resultText;
  }

  public void setResultText(String resultText) {
    this.resultText = resultText;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Recipient recipient = (Recipient) o;
    return Objects.equals(this.job, recipient.job) &&
        Objects.equals(this.faxNumber, recipient.faxNumber) &&
        Objects.equals(this.faxNumberNorm, recipient.faxNumberNorm) &&
        Objects.equals(this.internationalDialingCode, recipient.internationalDialingCode) &&
        Objects.equals(this.name, recipient.name) &&
        Objects.equals(this.recipientReference, recipient.recipientReference) &&
        Objects.equals(this.fareZone, recipient.fareZone) &&
        Objects.equals(this.senderTime, recipient.senderTime) &&
        Objects.equals(this.resultCode, recipient.resultCode) &&
        Objects.equals(this.resultText, recipient.resultText);
  }

  @Override
  public int hashCode() {
    return Objects.hash(job, faxNumber, faxNumberNorm, internationalDialingCode, name, recipientReference, fareZone, senderTime, resultCode, resultText);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Recipient {\n");
    
    sb.append("    job: ").append(toIndentedString(job)).append("\n");
    sb.append("    faxNumber: ").append(toIndentedString(faxNumber)).append("\n");
    sb.append("    faxNumberNorm: ").append(toIndentedString(faxNumberNorm)).append("\n");
    sb.append("    internationalDialingCode: ").append(toIndentedString(internationalDialingCode)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    recipientReference: ").append(toIndentedString(recipientReference)).append("\n");
    sb.append("    fareZone: ").append(toIndentedString(fareZone)).append("\n");
    sb.append("    senderTime: ").append(toIndentedString(senderTime)).append("\n");
    sb.append("    resultCode: ").append(toIndentedString(resultCode)).append("\n");
    sb.append("    resultText: ").append(toIndentedString(resultText)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
